#ifdef LOCAL
#include "../testlib.h"
#else
#include "testlib.h"
#endif

using namespace std;

const int MAX_N = 100'000, MAX_M = 100'000;
const long long MAX_VAL = (1LL << 15) - 1;

int n;

void readRange(const string& q_s) {
    int l = inf.readInt(1, n, "l_" + q_s);
    inf.readSpace();
    inf.readInt(l, n, "r_" + q_s);
}

void readQ1(const string& q_s) {
    readRange(q_s);
}

void readQ2(const string& q_s) {
    readRange(q_s);
    inf.readSpace();
    inf.readLong(0, MAX_VAL, "x_" + q_s);
}

void readQ3(const string& q_s) {
    readQ2(q_s);
    inf.readSpace();
    inf.readToken("&|\\||^", "f type for " + q_s);
}

void readQuery(int q) {
    string q_s = toString(q);
    int t = inf.readInt(1, 3, "type for query " + q_s);
    inf.readSpace();
    if (t == 1) {
        readQ1(q_s);
    } else if (t == 2) {
        readQ2(q_s);
    } else {
        readQ3(q_s);
    }
    inf.readEoln();
}

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);
    n = inf.readInt(1, MAX_N, "n");
    inf.readSpace();
    int m = inf.readInt(1, MAX_M, "m");
    inf.readEoln();
    inf.readLongs(n, 0, MAX_VAL, "a");
    inf.readEoln();
    for (int i = 0; i < m; i++) {
        readQuery(i + 1);
    }
    inf.readEof();
}
